from pyswip import *
import re


def prefix_to_infix(prefix_expr):
    #print(prefix_expr)
    prefix_expr = prefix_expr.replace(' ','')
    exprs = '(),'
    b_operators = ['tree','=>','->','and','or']
    s_operators = ['neg']
    token = ''
    tokens = []
    for i in prefix_expr:
        if i in exprs:
            if token != '':
                tokens.append(token)
            token = ''
        else:
            token += i
    if(token != ''):
        tokens.append(token)
    #print(tokens)
    stack = []
    for t in reversed(tokens):
        if t in b_operators:
            operand1 = stack.pop()
            operand2 = stack.pop()
            stack.append(f"({operand1} {t} {operand2})")
        elif t in s_operators:
            operand = stack.pop()
            stack.append(f"{t}({operand})")
        else:
            stack.append(t)
    #print(stack)
    return stack[0]


def extract_f(s):
    # Trova tutti i token principali all'interno del nodo tree
    main_tokens = []
    token = ""
    depth = 0
    in_f = False
    for char in s:
        if char == 'F':
            token += char
            in_f = True
        elif in_f:
            token += char
            if char == "(" :
                depth +=1
            elif char == ')':
                depth -= 1
                if depth == 0:
                    main_tokens.append(token)
                    token = ""
                    in_f = False

    return main_tokens

def clean_args(s):
    #print(s)
    if '(' in s :
        match = re.match(r'(neg|and|or|->|=>)\((\w+), (\w+)\)', s)
        #print(match)
        return f"({match.group(2)} {match.group(1)} {match.group(3)})" if match else None
    
    return s

def clean_f(s):
    #print(s)
    s = s[8:-1:]
    main_tokens = []
    token = ""
    depth = 0
    for char in s:
        token += char
        if char == ',' and depth == 0:
            main_tokens.append(token[:-1])
            token = ''
        if char == "(" :
            depth +=1
        if char == ')':
            depth -= 1

    main_tokens.append(token)
    if len(main_tokens) == 3:
        f = Functor(int(main_tokens[0]),int(main_tokens[1]),main_tokens[2])
        name = f.name
        left = main_tokens[2]
        cleaned = prefix_to_infix(left)
        #print(cleaned)
        return f"{name} {cleaned}"
    f = Functor(int(main_tokens[0]),int(main_tokens[1]),main_tokens[2],main_tokens[3])
    name = f.name
    left = main_tokens[2]
    right = main_tokens[3]

    #print(left)
    #print(right)

    left = prefix_to_infix(left)
    right = prefix_to_infix(right)

    #print(left)
    #print(right)

    return f"{left} {name} {right}"

def extract_atoms_and_functors(s):
    # Trova tutti gli atomi e i funtori nella stringa
    matches_a = re.findall(r"Atom\('\d+'\)", s)
    matches_f = extract_f(s)
    #print(matches_f)
    #matches_f = regex.findall(r"^Functor\((\d+),(\d+),(?:\w+|neg\((\w+)|and\((\w+), (\w+)|or\((\w+), (\w+)|->\((\w+), (\w+)|=>\((\w+), (\w+))\))\)", s, flags=regex.BESTMATCH)
    
    # Rimuovi i duplicati mantenendo l'ordine di apparizione
    unique_matches_a = list(dict.fromkeys(matches_a))
    unique_matches_f = list(dict.fromkeys(matches_f))

    return unique_matches_a,unique_matches_f

def clean_atom(s):
    numero_atomo = int(s.split("'")[1])
    x = Atom(numero_atomo)
    return x.value
'''
def clean_functor(s):

    ID, arity, *args = map(str.strip, s.split('(')[1].split(')')[0].split(','))
    funtore = Functor(int(ID), int(arity), args)
    res = funtore.__str__()
    print(res)
    match = re.match(r'(neg|and|or|->|=>)\((\w+), (\w+)\)', res)
    print(match)
    return f"{match.group(2)} {match.group(1)} {match.group(3)}" if match else None
'''
def clean_string(s):

    list_a,list_f = extract_atoms_and_functors(s)
    real_names = {x:clean_atom(x) for x in list_a}
    real_names.update({x:clean_f(x) for x in list_f})

    #print(real_names)
    for old_key, new_value in real_names.items():
        s = s.replace(old_key, new_value)
    
    return s

if __name__ == '__main__':
    prolog = Prolog()
    prolog.consult('ckcemmpidcs_interface.pl')
    #print(list(prolog.query('pr(a=>a,Tree)')))
    #print(prolog.query('pr(a=>a,Tree)'))
    #print(list(prolog.query('pr(a => b,Tree).')))
    query = prolog.query('pr(a=>a,Tree)')


    out = "tree(cs, tree(condR, tree(id, tree(assioma, null, null, [[[Atom('437509'), Atom('273413')]], [[Atom('428933'), Atom('273413'), Atom('437509')]], []], [[[Atom('437509'), Atom('273413')], [Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), null, [[], [[Atom('428933'), Atom('273413'), Atom('437509')]], []], [[[Atom('437509'), Atom('273413')], [Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), null, [[], [], []], [[[Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), tree(condR, tree(id, tree(assioma, null, null, [[[Atom('437509'), Atom('273413')]], [[Atom('428933'), Atom('273413'), Atom('437509')]], []], [[[Atom('437509'), Atom('273413')], [Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), null, [[], [[Atom('428933'), Atom('273413'), Atom('437509')]], []], [[[Atom('437509'), Atom('273413')], [Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), null, [[], [], []], [[[Atom('428933'), Atom('273413')]], [], [[Atom('428933'), Functor(8708365,2,a,a)]]]), [[], [], []], [[], [], [[Atom('428933'), Functor(8708365,2,a,a)]]])"


    print(clean_string(out))


"""
Un'espressione regolare da usare con re.findall() che catturi elementi all'interno di una stringa che hanno questa grammatica:
Functor(n,n,A,A)

con n numero intero
e A che può essere:
    un valore letterale w
    oppure un J(w, w)
        con J che vale un valore tra =>, ->, or, and, neg


"""
grammar = """
Functor ::= "Functor" "(" n1 ", " n2 ", A1 ", " A2 ")"

n1 ::= [0-9]+

n2 ::= [0-9]+

A ::= "w" | "J"

J ::= "=>" "(" w ", " w ")" | "->" "(" w ", " w ")" | "and" "(" w ", " w ")" | "or" "(" w ", " w ")" | "not" "(" w " ")"

w ::= [a-zA-Z]+
"""