from strings_ex import *
from pylatex import Document, Section, Subsection, Command, Package
from pylatex.utils import italic, NoEscape


class MyDocument(Document):
    def __init__(self,title):
        geometry_options = {"landscape": "true", "margin": "1.5cm"}  # Imposta l'orientamento e i margini
        super().__init__(documentclass='article', geometry_options=geometry_options)
        self.preamble.append(Package('./LaTex/prooftree'))
        self.preamble.append(Command('input','./LaTex/macrosAIIA.tex'))
        self.preamble.append(Command('title', title))
        #self.preamble.append(Command('author', 'Anonymous author'))
        self.preamble.append(Command('date', NoEscape(r'')))
        self.append(NoEscape(r'\maketitle'))


def create_doc(title,text,name = 'Tree'):
    # Document
    doc = MyDocument(title)

    # Add stuff to the document
    #with doc.create(Section(NoEscape('$A \cond A$'))):
    doc.append(NoEscape(text))
        #doc.append(NoEscape(tree_str))
    #geometry_options = {"landscape": "true", "margin": "1.5cm"}  # Imposta l'orientamento e i margini
    #doc = Document(documentclass='article', geometry_options=geometry_options)

    doc.generate_pdf(f'./Pdf/{name}', clean_tex=True)
    tex = doc.dumps()  # The document as string in LaTeX syntax

if __name__ == '__main__':
    create_doc('$A \cond A$', output_latex)