import tkinter as tk
from tkinter import ttk
import webbrowser
from main import general_pipe

def show_pdf():
    condition = entry.get()  # Get text from the text box
    webbrowser.open('./Pdf/new_tree.pdf')  # Opens the PDF in the default browser

def read_input():
    pdf_button.pack_forget()
    text = entry.get()
    selected_checkboxes = [checkbox_list[i] for i, var in enumerate(checkbox_vars) if var.get() == 1]
    print("Selected Checkboxes:", selected_checkboxes)
    ckboxes = ''.join(selected_checkboxes)
    file_name = f'ck{ckboxes}.pl'
    print(f"Entered Text: {text}")  # Prints the text in the console
    is_valid = general_pipe(text, file_name)

    # Aggiorna il colore del testo della label
    if is_valid:
        validation_label.config(text="Valid", foreground="green")
        # Ottieni i testi delle checkbox selezionate

    else:
        validation_label.config(text="Not Valid", foreground="red")

    # Aggiorna lo stato del pulsante "Show PDF"
    update_pdf_button_state()

def toggle_checkboxes():
    # Toggle the state of all checkboxes based on the "Select All" checkbox
    all_selected = select_all_var.get()
    for checkbox_var in checkbox_vars:
        checkbox_var.set(all_selected)

    # Aggiorna lo stato del pulsante "Show PDF"
    update_pdf_button_state()

def update_pdf_button_state():
    # Enable or disable the "Show PDF" button based on checkbox states and validation status
    if validation_label.cget("text") == "Valid":
        pdf_button.config(state=tk.NORMAL)
        pdf_button.pack(side=tk.TOP, anchor=tk.CENTER)  # Center the button
    else:
        pdf_button.config(state=tk.DISABLED)
        pdf_button.pack_forget()

# Create the main window
root = tk.Tk()
root.title("PDF Viewer")

# Set a custom style
style = ttk.Style()
style.theme_use("clam")

# Adjust the size of the main window
root.geometry("400x350")

# Add a text box with larger dimensions
entry = ttk.Entry(root, font=("Arial", 14))
entry.pack(pady=10)

# Add the button to read input from the text box
read_button = ttk.Button(root, text="Read Input", command=read_input, style="Accent.TButton")
read_button.pack(pady=10)

# Add the label to show validation status (initially empty)
validation_label = ttk.Label(root, text="", font=("Arial", 12))
validation_label.pack()

# Add checkboxes with "Select All" functionality
checkbox_list = ['cem', 'mp', 'cs', 'id']
checkbox_vars = [tk.IntVar() for _ in checkbox_list]

select_all_var = tk.IntVar()

select_all_checkbox = ttk.Checkbutton(root, text="Select All", variable=select_all_var, command=toggle_checkboxes)
select_all_checkbox.pack()

# Divide the list of checkboxes into two columns
num_columns = 2
frame = ttk.Frame(root)
frame.pack()

for i, checkbox_value in enumerate(checkbox_list):
    checkbox = ttk.Checkbutton(frame, text=checkbox_value, variable=checkbox_vars[i])
    checkbox.pack(side=tk.LEFT, padx=5)  # Align to the left with padding

# Add an empty space
empty_space = ttk.Label(root, text="", font=("Arial", 12))
empty_space.pack()

# Add the button to show the PDF (initially hidden)
pdf_button = ttk.Button(root, text="Show PDF", command=show_pdf, style="Accent.TButton", state=tk.DISABLED)

# Run the GUI
root.mainloop()
