# Clean

A Theorem prover for Conditional Logics

![alt text](GUI.png)

## Requirements

This project is intended for use on Ubuntu with a specific version of SWI-Prolog.

- **Operating System:** Ubuntu
- **SWI-Prolog Version:** 7.6.x or 8.4.x (or compatible)
- Python libraries listed in requirements.txt

## Installation and run

1. Ensure you have [SWI-Prolog](https://www.swi-prolog.org/) version 7.6.x installed on your Ubuntu system. If not, follow the [installation instructions](https://www.swi-prolog.org/Download.html) provided by SWI-Prolog's official website.
2. Install all the requirements libraries by running: __pip install -r requirements.txt__
3. Run the GUI using python3

## Acknowledgment
We thank Nicola Olvetti and Nikola Panic for their contribution to the development of CondLean and of preliminary versions of CLean.

## Project status
Currently under development.


## Getting started

To make it easy for you to get started with GitLab, here's a list of recommended next steps.

Already a pro? Just edit this README.md and make it your own. Want to make it easy? [Use the template at the bottom](#editing-this-readme)!

## Add your files

- [ ] [Create](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#create-a-file) or [upload](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#upload-a-file) files
- [ ] [Add files using the command line](https://docs.gitlab.com/ee/gitlab-basics/add-file.html#add-a-file-using-the-command-line) or push an existing Git repository with the following command:

```
cd existing_repo
git remote add origin https://gitlab2.educ.di.unito.it/pozzato/clean.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab2.educ.di.unito.it/pozzato/clean/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Automatically merge when pipeline succeeds](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing(SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

***

## License
Copyright 2023 by Valentina Gliozzi, Gian Luca Pozzato, Gabriele Tessore, Alberto Valese

This file is part of Clean.

Clean is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Clean is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Clean.  If not, see [http://www.gnu.org/licenses/](http://www.gnu.org/licenses/).

